package com.tistory.antop.mybatis;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.transaction.TransactionConfiguration;
import org.springframework.transaction.annotation.Transactional;

import com.tistory.antop.mybatis.entity.Employee;
import com.tistory.antop.mybatis.mapper.EmployeeMapper;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = "classpath:config/spring/context-common.xml")
@TransactionConfiguration(transactionManager = "transactionManager", defaultRollback = true)
@Transactional
public class TypeHandlerTest {

	// log4j
	private Logger logger = Logger.getLogger(getClass());

	// mapper
	@Autowired
	private EmployeeMapper mapper;

//	@Test
	public void insert() {
		logger.info("// begin insert");

		// insert
		Employee employee = new Employee();
		employee.setName("안정용");
		employee.setUseYn(false);

		mapper.insert(employee);

		// select
		employee = mapper.selectById(employee.getSeq());
		logger.info(employee);

		logger.info("// end insert");
	}

//	@Test
	public void update() {
		logger.info("// begin update");

		// insert
		Employee employee = new Employee();
		employee.setName("안정용");

		employee.setUseYn(true);

		mapper.insert(employee);

		// select
		employee = mapper.selectById(employee.getSeq());

		logger.info(employee);

		// update
		employee.setUseYn(false);
		mapper.update(employee);

		// select
		employee = mapper.selectById(employee.getSeq());
		logger.info(employee);

		logger.info("// end update");
	}

//	@Test
	public void delete() {
		logger.info("// begin delete");

		// insert
		Employee employee = new Employee();
		employee.setName("안정용");
		employee.setUseYn(true);

		mapper.insert(employee);

		// delete
		mapper.deleteById(employee.getSeq());

		// select
		employee = mapper.selectById(employee.getSeq());
		logger.info("employee is null ? " + (employee == null));

		logger.info("// end delete");
	}

	@Test
	public void select() {
		logger.info("// begin select");

		Map<String, Object> map = new HashMap<String, Object>();
		map.put("name", "안");

		List<Employee> employees = mapper.selectByMap(map);

		logger.info("selected employee = " + employees.size());

		for (Employee employee : employees) {
			logger.info(employee);
		}

		logger.info("// end select");
	}

}
